'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Created by Tears on 2017/8/31.
 */
/*
* Created By Tears
* Name SafeObject
* Decription: create a new safed object which will be safed when you call get or set method of it,
* Example:target object is emptyObject={},use it to create a safeObject,and then ,access the attribute of it ,
*           expmple: emptyObject.someAttribute, result is undefined, safeObject.someAttribute is ''
* params:
*   target:target object to protect
*   options:
*       emptyString: result when access some attribute
* */
var SafeObject = function SafeObject(target, options) {
    _classCallCheck(this, SafeObject);

    if (options && options.emptyString) {
        SafeObject.defaultEmptyString = options.emptyString;
    }
    this.handler = {
        get: function get(target, key, receiver) {
            if (!target) {
                console.warn('target is undefined,we will create it!');
                target = {};
            }
            if (!target[key]) {
                console.warn(target[key] + ' is not defined,we will created attribute ' + key + ' with ' + SafeObject.defaultEmptyString);
                target[key] = SafeObject.defaultEmptyString;
            }
            return Reflect.get(target, key, receiver);
        }
    };
    return new Proxy(target, this.handler);
};

SafeObject.defaultEmptyString = '';
exports.default = SafeObject;
//# sourceMappingURL=index.js.map