'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _antd = require('antd');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } } /**
                                                                                                                                                           * Created by Tears on 2017/8/28.
                                                                                                                                                           */
/**
 * Created by Tears on 2017/8/28.
 */


var Option = _antd.Select.Option;
var Search = _antd.Input.Search;
var RadioButton = _antd.Radio.Button;
var RadioGroup = _antd.Radio.Group;

var RangePicker = _antd.DatePicker.RangePicker;

var FilterComponents = function FilterComponents() {
    _classCallCheck(this, FilterComponents);
};

FilterComponents.getRangePickerCompent = function (handler) {
    return _react2.default.createElement(RangePicker, { onChange: handler });
};

FilterComponents.getTextFilterComponent = function (placeholder, handler) {
    return _react2.default.createElement(_antd.Input, { type: 'text', placeholder: placeholder, onBlur: handler });
};

FilterComponents.getSelectFilterComponent = function (_ref) {
    var data = _ref.data,
        placeholder = _ref.placeholder,
        handler = _ref.handler;

    var getSelectOptions = function getSelectOptions(data) {
        if (data && data.length > 0) {
            return data.map(function (item, index) {
                return _react2.default.createElement(
                    Option,
                    { key: index, value: item.value || '' },
                    item.name
                );
            });
        }
    };

    return _react2.default.createElement(
        _antd.Select,
        { onChange: handler, style: { width: '100%' }, showSearch: true, placeholder: placeholder },
        getSelectOptions(data)
    );
};

FilterComponents.getSearchFilterComponent = function (placeholder, handler) {

    return _react2.default.createElement(Search, { placeholder: placeholder, onSearch: function onSearch(value) {
            handler(value);
        } });
};

FilterComponents.getRadioGroupButton = function (handler, radioButtonData) {

    var getRadioItem = function getRadioItem(data) {
        if (data && data.length > 0) {
            return data.map(function (item, index) {
                return _react2.default.createElement(
                    RadioButton,
                    { key: index, value: item.value },
                    item.content
                );
            });
        }
        return '';
    };

    return _react2.default.createElement(
        RadioGroup,
        { onChange: handler },
        getRadioItem(radioButtonData)
    );
};

exports.default = FilterComponents;
//# sourceMappingURL=FilterComponent.js.map