'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _FilterComponent = require('./FilterComponent');

var _FilterComponent2 = _interopRequireDefault(_FilterComponent);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//fieldsProps=[{keyName:'',filterList:[{name:'',operator:'',value:''}]}]
/*  form搜索过滤器组件*/
/**
 * Created by Tears on 2017/8/26.
 */
var FilterItem = function FilterItem(_ref) {
    var componentProps = _ref.componentProps,
        fieldsProps = _ref.fieldsProps,
        _ref$form = _ref.form,
        getFieldDecorator = _ref$form.getFieldDecorator,
        getFieldsValue = _ref$form.getFieldsValue,
        resetFields = _ref$form.resetFields;
    var type = componentProps.type,
        placeholder = componentProps.placeholder,
        clearState = componentProps.clearState,
        data = componentProps.data,
        handler = componentProps.handler,
        radioButtonData = componentProps.radioButtonData,
        initValue = componentProps.initValue;


    var onChange = function onChange(payload) {
        var fields = getFieldsValue();

        var fieldsData = {}; //fieldsData={'keyName':[{name:'',operator:'',value:''}]}
        Object.keys(fields).map(function (key) {

            fieldsData[key] = [];
            var filterList = fieldsProps.filterList;
            var isMuilti = fieldsProps.isMulti;
            if (isMuilti) {
                if (type === 'radioButton') {

                    if (filterList) {
                        if (payload && payload.target && payload.target.value !== 'all') {

                            var fieldItem = filterList[payload.target.value];
                            fieldItem.map(function (item) {
                                var field = {};
                                field.name = item.name || '';
                                field.operator = item.operator || '';
                                field.value = item.value;

                                fieldsData[key].push(field);
                            });
                        }
                    }
                }
                if (type == 'rangePicker') {
                    if (payload && payload.length > 0) {
                        payload.map(function (item, index) {
                            var field = {};
                            field.name = filterList[index].name || '';
                            field.operator = filterList[index].operator || '';
                            field.value = item;

                            fieldsData[key].push(field);
                        });
                    }
                }
            } else if (filterList.length > 0) {
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = filterList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var filter = _step.value;

                        if (type === 'select') {
                            if ((payload || payload > -1) && payload !== 'all') {
                                var field = {};
                                field.name = filter.name || '';
                                field.operator = filter.operator || '';
                                field.value = payload;
                                fieldsData[key].push(field);
                            } else {
                                continue;
                            }
                        } else if (type === 'radioButton') {
                            if (payload && payload.target && payload.target.value !== 'all') {
                                var _field = {};
                                _field.name = filter.name || '';
                                _field.operator = filter.operator || '';
                                _field.value = payload.target.value;

                                fieldsData[key].push(_field);
                            } else {
                                continue;
                                // fieldsData='clear'
                                // break
                            }
                        } else if (fields[key] !== 'all') {
                            var _field2 = {};
                            _field2.name = filter.name || '';
                            _field2.operator = filter.operator || '';
                            _field2.value = fields[key];
                            fieldsData[key].push(_field2);
                        } else {
                            continue;
                            // fieldsData='clear'
                            // break
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
        });
        console.info(fieldsData);

        handler(fieldsData);
    };
    var componentType = { text: _FilterComponent2.default.getTextFilterComponent(placeholder, onChange), select: _FilterComponent2.default.getSelectFilterComponent({ data: data, placeholder: placeholder, handler: onChange }),
        search: _FilterComponent2.default.getSearchFilterComponent(placeholder, onChange),
        radioButton: _FilterComponent2.default.getRadioGroupButton(onChange, radioButtonData),
        rangePicker: _FilterComponent2.default.getRangePickerCompent(onChange)
    };

    return _react2.default.createElement(
        'div',
        null,
        clearState ? resetFields() : '',
        type === 'radioButton' || type === 'select' ? getFieldDecorator(fieldsProps.keyName, { initialValue: initValue ? initValue : 'all' })(componentType[type]) : type === 'rangePicker' ? getFieldDecorator(fieldsProps.keyName, { initialValue: initValue && initValue.length > 1 ? [(0, _moment2.default)(initValue[0], 'YYYY-MM-DD'), (0, _moment2.default)(initValue[1], 'YYYY-MM-DD')] : [] })(componentType[type]) : getFieldDecorator(fieldsProps.keyName)(componentType[type])
    );
};
exports.default = _antd.Form.create()(FilterItem);
//# sourceMappingURL=index.js.map